// Scourge "Skeleton" engine. Only does the very basic task of initializing SDL + OpenGL and catches any errors

#ifndef SCOURGE_SK_H
#define SCOURGE_SK_H

#include "scourge_debug.h"
#include "SDL.H"
#include "gl/gl.h"
#include "gl/glu.h"

typedef struct
{
    int width;
    int height;
    int bpp;
    const SDL_VideoInfo* info;
    int flags;
}SC_WinInfo;

class SC_SK_Engine
{
    public:
    SC_WinInfo scWin; // Contains data pertaining to the width, height and color depth of the window

    void initGL(bool loadDefaults = true); // Initializes the GL subsystem

    SC_SK_Engine(bool loadDefaults = true); // Constructor
    virtual ~SC_SK_Engine(); // Virtual Destructor

};

#endif
