// Simple Scourge application

#include <cstdlib>
#include <math.h>
#include "scourge_app.h"

#define TIME_INTERVAL 30
/// Time interval, AKA the delay between each frame. The smaller the number, the higher the framerate

using namespace std;

SC_SK_Engine *gEngine;
SC_TEXTURE* txScLogo;

int gEvents();
int KeyDown(SDL_keysym* vkey);
void dresize(float w, float h, res_mode mode);

int main ( int argc, char** argv )
{
    bool done = false; // While this is false, the game loop will run



    // Initialize the engine
    gEngine = new SC_SK_Engine();

    // Start OpenGL system
    gEngine->initGL();

    glEnable(GL_TEXTURE_2D);
    glEnable(GL_COLOR_MATERIAL);

    // Set Ortho (2D) perspective
    dresize(640,480,ortho);

    // Initialize the timer
    next_time = SDL_GetTicks() + TIME_INTERVAL;

    txScLogo = new SC_TEXTURE("./scourgelogo.bmp");

    /// Game loop

    while(!done)
    {
        if(gEvents() == -99)
        {
            // Done
            done = true;
        }

        /// Put game-code and draw-code here. I recommend putting them in external functions to keep the mainline tidy
        glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
        glLoadIdentity();

        glColor3f(1,1,1);
        glBindTexture(GL_TEXTURE_2D,txScLogo->tex);

        glBegin(GL_QUADS);
        glTexCoord2f(0,0); glVertex2i(0,0);
        glTexCoord2f(1,0); glVertex2i(639,0);
        glTexCoord2f(1,1); glVertex2i(639,479);
        glTexCoord2f(0,1); glVertex2i(0,479);
        glEnd();

        SDL_GL_SwapBuffers();
    }

    // Exit
    delete gEngine;
    return 0;
}

/// Event processing

int gEvents()
{
    SDL_Event event;

    while(SDL_PollEvent(&event))
    {

        switch(event.type)
        {
        case SDL_KEYDOWN:
            // Put key-down code here (Same as GM's Key Pressed)
            return KeyDown(&event.key.keysym);
            break;
        case SDL_KEYUP:
            // Put key-up code here (Same as GM's Key Release)
            break;
        case SDL_MOUSEMOTION:
            // Put mousecode here
            break;
        case SDL_QUIT:
            return 99;
            break;
        }
    }
    return 1;
}

/// Key handling

int KeyDown(SDL_keysym* vkey)
{
    // Key press event

    switch(vkey->sym)
    {
        case SDLK_ESCAPE:
        return -99; // Exit code
        break;

        default:
        break;
    }

    return 0;
}

// A handy function to switch between Ortho and 3D perspective

void dresize(float w, float h, res_mode mode)
{
    if(h == 0)
        h = 1;

    glViewport(0,0,(int)w,(int)h);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    if(mode == projection)
    {
        gluPerspective(45.0,w/h,0.1,100.0);
    }
    if(mode == ortho)
    {
        glOrtho(0.0f,w,h,0.0f,-1.0f,1.0f);
    }

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}
